#include <hidef.h>					/* common defines and macros */
#include "derivative.h"			/* derivative-specific definitions */
#include "iic.h"


/////////////////////////////////////////////////////

unsigned char IS_BIT_SET(unsigned char dato, unsigned char nbit){
	unsigned char aux;
	
	aux = (1<<nbit);

	if (aux & dato)	return HIGH;
	else return LOW;
	
}

void I2C_DELAY(void){
//	unsigned char i;
//  for(i=0;i<10;i++)
    asm (nop);
}

void I2C_SCL_OUTPUT(void){
	SCL_DIR = OUTPUT;
}

void I2C_SET_SCL(void){
	SCL_DIR = OUTPUT;
	SCL = HIGH;
}

void I2C_CLEAR_SCL(void){
	SCL_DIR = OUTPUT;
	SCL = LOW;
}

void I2C_SDA_INPUT(void){
	SDA_DIR = INPUT;
}

void I2C_SDA_OUTPUT(void){
	SDA_DIR = OUTPUT;
}

void I2C_SET_SDA(void){
	SDA_DIR = OUTPUT;
	SDA = HIGH;
}

void I2C_CLEAR_SDA(void){
	SDA_DIR = OUTPUT;
	SDA = LOW;
}

unsigned char I2C_GET_SDA(void){
	SDA_DIR = INPUT;
	return SDA;
}

void i2c_init(void){
	I2C_SCL_OUTPUT();
	I2C_SET_SCL();
	I2C_SDA_OUTPUT();
	I2C_SET_SDA();
}

void i2c_scl_toggle()
{
	I2C_SET_SCL();
	I2C_DELAY();
	I2C_CLEAR_SCL();
	I2C_DELAY();
}


void i2c_clk_gen(void){
	unsigned char i;
  
	for(i=0;i<8;i++) i2c_scl_toggle();
    
	I2C_SET_SCL();
}

void i2c_start(void){
	I2C_CLEAR_SDA();
 	I2C_DELAY();
	I2C_CLEAR_SCL();
	I2C_DELAY();
}

void i2c_restart(void){
	I2C_SET_SDA();
	I2C_DELAY();
	I2C_SET_SCL();
	I2C_DELAY();
	i2c_start();
}

void i2c_stop(void){
	I2C_CLEAR_SDA();
	I2C_DELAY();
	I2C_SET_SCL();
	I2C_DELAY();
	I2C_SET_SDA();
}

unsigned char ack_iic;
unsigned char i2c_put_byte(unsigned char dato)
{
	signed char i;
	for (i = 7; i >= 0; i--){

		//if (IS_BIT_SET(dato,i)) I2C_SET_SDA();
         //                else I2C_CLEAR_SDA();
		SDA=dato>>i;
    
	i2c_scl_toggle();
	}

	I2C_SDA_INPUT();
	I2C_SET_SCL();
	I2C_DELAY();
	ack_iic = I2C_GET_SDA();
	I2C_DELAY();
	I2C_CLEAR_SCL();
	I2C_SDA_OUTPUT();

  return !ack_iic;
}

unsigned char i2c_get_byte(signed long last){
	unsigned char aux = 0;
	signed char i;

	I2C_CLEAR_SCL();

	I2C_SDA_INPUT();

	for (i = 7; i >= 0; i--) {
		I2C_SET_SCL();
		I2C_DELAY();
		aux <<= 1;
		if (I2C_GET_SDA()) aux |= 1;
    	I2C_CLEAR_SCL();
    	I2C_DELAY();
	}

	I2C_SDA_OUTPUT();

	if (last) I2C_SET_SDA();
	else    I2C_CLEAR_SDA();

	i2c_scl_toggle();

	return aux;
}

unsigned char i2c_write(unsigned char dev,unsigned char *data,unsigned char len){
	unsigned char i;

	i2c_start();										// START

	if (!i2c_put_byte(dev)){			// TX address para write
    i2c_stop();
    I2C_DELAY();
    I2C_DELAY();
    return I2C_NOK;
	}

	for (i=0;i<len;i++){
	  
		if (!i2c_put_byte(*data++)){		// TX dir de registro (la cantidad de bytes que sea)
	    	i2c_stop();
	    	I2C_DELAY();
	    	I2C_DELAY();
	    	return I2C_NOK;
	  	}
	}
	
	i2c_stop();										// STOP
	I2C_DELAY();
	I2C_DELAY();

	return I2C_OK;
}

unsigned char i2c_read(unsigned char dev,unsigned char len_add,unsigned char *data,unsigned char len){
	unsigned char i;

	i2c_start();										// START

	if (!i2c_put_byte(dev)){			// TX address para write
    i2c_stop();
    I2C_DELAY();
    I2C_DELAY();
    return I2C_NOK;
	}

	for (i=0;i<len_add;i++){
	  if (!i2c_put_byte(*data++)){		// TX dir de registro (la cantidad de bytes que sea)
	    i2c_stop();
	    I2C_DELAY();
	    I2C_DELAY();
	    return I2C_NOK;
	  }
	}
	
	dev = dev | 0x01;							// Address para lectura				
	for (i=0;i<len_add;i++) data--;				// Acomoda puntero de recepcin

	i2c_restart();									// Repeated start
	I2C_DELAY();
	I2C_DELAY();

	if (!i2c_put_byte(dev)){			// TX address para read
    	i2c_stop();
    	I2C_DELAY();
		I2C_DELAY();
    	return I2C_NOK;
  }

	I2C_DELAY();

	for (i=len;i>0;i--)												// Lee la cantidad de registros pedidos
    	*data++ = i2c_get_byte(i==0);

	I2C_DELAY();

  
	i2c_stop();										// STOP
	I2C_DELAY();
	I2C_DELAY();

	if (!I2C_GET_SDA()){
    	i2c_clk_gen();
      	I2C_SET_SDA();
  	}


	return I2C_OK;

}
