#include <hidef.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */
#include "iic.h"
#include "mpu6050.h"

void MCG_Init(void);

static unsigned char who_i_am=FALSE;
void main(void) {
	SOPT1_COPT=0;
	
	i2c_init();
	who_i_am=MPU6050_TestConnection();
	
	(void)MPU6050_Initialize();
	EnableInterrupts;
	/* include your code here */

  

	for(;;) {
		__RESET_WATCHDOG();	/* feeds the dog */
	} /* loop forever */
	/* please make sure that you never leave main */
}


//XTAL 12 -> fBus 24MHz
void MCG_Init(void){
	/* the MCG is default set to FEI mode, it should be change to FBE mode*/
	MCGC2=	MCGC2_RANGE_MASK|MCGC2_HGO_MASK|MCGC2_EREFS_MASK|MCGC2_ERCLKEN_MASK;
                       
	while(!MCGSC_OSCINIT);

    MCGC1=	MCGC1_CLKS1_MASK | MCGC1_RDIV1_MASK | MCGC1_RDIV0_MASK | 
    		MCGC1_IRCLKEN_MASK | MCGC1_IREFSTEN_MASK;

	while((MCGSC & 0x1C ) != 0x08);		// check the external reference clock is selected or not

	/* Switch to PBE mode from FBE */

    MCGC3=	MCGC3_PLLS_MASK | MCGC3_VDIV3_MASK;
    while ((MCGSC & 0x48) != 0x48);		//wait for the PLL is locked & 

	/* Switch to PEE mode from PBE mode */
	MCGC1&= MCGC1_RDIV2_MASK | MCGC1_RDIV1_MASK | MCGC1_RDIV0_MASK | 
	        MCGC1_IREFS_MASK | MCGC1_IRCLKEN_MASK | MCGC1_IREFSTEN_MASK;
	        
	while((MCGSC & 0x6C) != 0x6C);
}
